Botan 2.19.5 Crypto and TLS for C&

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Botan::RSA_PublicKey Class Reference

`#include <rsa.h>`

Inheritance diagram for Botan::RSA_PublicKey:

## Public Member Functions
std::string | algo_name () const override
AlgorithmIdentifier | algorithm_identifier () const override
bool | check_key (RandomNumberGenerator &rng, bool) const override
std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &params, const std::string &provider) const override
virtual Signature_Format | default_x509_signature_format () const
size_t | estimated_strength () const override
std::string | fingerprint_public (const std::string &alg="SHA-256") const
const BigInt & | get_e () const
const BigInt & | get_n () const
virtual OID | get_oid () const
size_t | key_length () const override
virtual size_t | message_part_size () const
virtual size_t | message_parts () const
std::shared_ptr< const RSA_Public_Data > | public_data () const
std::vector< uint8_t > | public_key_bits () const override
| RSA_PublicKey (const AlgorithmIdentifier &alg_id, const std::vector< uint8_t > &key_bits)
| RSA_PublicKey (const BigInt &n, const BigInt &e)
std::vector< uint8_t > | subject_public_key () const

## Protected Member Functions
void | init (BigInt &&n, BigInt &&e)
| RSA_PublicKey ()=default

## Protected Attributes
std::shared_ptr< const RSA_Public_Data > | m_public

## Detailed Description

RSA Public Key

Definition at line 25 of file rsa.h.

## Constructor & Destructor Documentation

## ◆ RSA_PublicKey() [1/3]

Botan::RSA_PublicKey::RSA_PublicKey | ( | const AlgorithmIdentifier & | alg_id,
|  | const std::vector< uint8_t > & | key_bits
| ) |  |

Load a public key.

Parameters

  alg_id | the X.509 algorithm identifier
  key_bits | DER encoded public key bits

Definition at line 114 of file rsa.cpp.

116 {
117 BigInt n, e;
118 BER_Decoder(key_bits)
119 .start_cons(SEQUENCE)
120 .decode(n)
121 .decode(e)
122 .end_cons();
123
124 init(std::move(n), std::move(e));
125 }
Botan::RSA_PublicKey::init
void init(BigInt &&n, BigInt &&e)
Definition: rsa.cpp:107
Botan::SEQUENCE
@ SEQUENCE
Definition: asn1_obj.h:42

References Botan::BER_Decoder::decode(), Botan::BER_Decoder::end_cons(), init(), Botan::SEQUENCE, and Botan::BER_Decoder::start_cons().

## ◆ RSA_PublicKey() [2/3]

Botan::RSA_PublicKey::RSA_PublicKey | ( | const BigInt & | n,
|  | const BigInt & | e
| ) |  |

Create a public key.

- n the modulus
- e the exponent

Definition at line 127 of file rsa.cpp.

128 {
129 BigInt n = modulus;
130 BigInt e = exponent;
131 init(std::move(n), std::move(e));
132 }

References init().

## ◆ RSA_PublicKey() [3/3]

Botan::RSA_PublicKey::RSA_PublicKey | ( |  | ) |
| protected default

## Member Function Documentation

## ◆ algo_name()

std::string Botan::RSA_PublicKey::algo_name | ( |  | ) | const
| inline override virtual

Get the name of the underlying public key scheme.

Returns
  name of the public key scheme

Implements Botan::Public_Key.

Definition at line 43 of file rsa.h.

43{ return "RSA"; }

Referenced by Botan::RSA_PrivateKey::create_decryption_op(), create_encryption_op(), Botan::RSA_PrivateKey::create_kem_decryption_op(), create_kem_encryption_op(), Botan::RSA_PrivateKey::create_signature_op(), create_verification_op(), and Botan::RSA_PrivateKey::RSA_PrivateKey().

## ◆ algorithm_identifier()

AlgorithmIdentifier Botan::RSA_PublicKey::algorithm_identifier | ( |  | ) | const
| override virtual

Returns
  X.509 AlgorithmIdentifier for this key

Implements Botan::Public_Key.

Definition at line 144 of file rsa.cpp.

145 {
146 return AlgorithmIdentifier(get_oid(), AlgorithmIdentifier::USE_NULL_PARAM);
147 }
Botan::AlgorithmIdentifier::USE_NULL_PARAM
@ USE_NULL_PARAM
Definition: asn1_obj.h:432
Botan::Public_Key::get_oid
virtual OID get_oid() const
Definition: pk_keys.cpp:53

References Botan::Public_Key::get_oid(), and Botan::AlgorithmIdentifier::USE_NULL_PARAM.

## ◆ check_key()

bool Botan::RSA_PublicKey::check_key | ( | RandomNumberGenerator & | rng,
|  | bool | strong
| ) |  | const
| override virtual

Test the key values for consistency.

Parameters

  rng | rng to use
  strong | whether to perform strong and lengthy version of the test

Returns
  true if the test is passed

Implements Botan::Public_Key.

Reimplemented in Botan::RSA_PrivateKey.

Definition at line 164 of file rsa.cpp.

165 {
166 if(get_n() < 35 || get_n().is_even() || get_e() < 3 || get_e().is_even())
167 return false;
168 return true;
169 }
Botan::RSA_PublicKey::get_n
const BigInt & get_n() const
Definition: rsa.cpp:104
Botan::RSA_PublicKey::get_e
const BigInt & get_e() const
Definition: rsa.cpp:105

References get_e(), and get_n().

## ◆ create_encryption_op()

std::unique_ptr< PK_Ops::Encryption > Botan::RSA_PublicKey::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 640 of file rsa.cpp.

643 {
644 if(provider == "base" || provider.empty())
645 return std::unique_ptr<PK_Ops::Encryption>(new RSA_Encryption_Operation(*this, params));
646 throw Provider_Not_Found(algo_name(), provider);
647 }
Botan::RSA_PublicKey::algo_name
std::string algo_name() const override
Definition: rsa.h:43

References algo_name().

## ◆ create_kem_encryption_op()

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::RSA_PublicKey::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 650 of file rsa.cpp.

653 {
654 if(provider == "base" || provider.empty())
655 return std::unique_ptr<PK_Ops::KEM_Encryption>(new RSA_KEM_Encryption_Operation(*this, params));
656 throw Provider_Not_Found(algo_name(), provider);
657 }

References algo_name().

## ◆ create_verification_op()

std::unique_ptr< PK_Ops::Verification > Botan::RSA_PublicKey::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 660 of file rsa.cpp.

662 {
663 if(provider == "base" || provider.empty())
664 return std::unique_ptr<PK_Ops::Verification>(new RSA_Verify_Operation(*this, params));
665
666 throw Provider_Not_Found(algo_name(), provider);
667 }

References algo_name().

## ◆ default_x509_signature_format()

virtual Signature_Format Botan::Public_Key::default_x509_signature_format | ( |  | ) | const
| inline virtual inherited

Reimplemented in Botan::GOST_3410_PublicKey.

Definition at line 125 of file pk_keys.h.

126 {
127 return (this->message_parts() >= 2) ? DER_SEQUENCE : IEEE_1363;
128 }
Botan::Public_Key::message_parts
virtual size_t message_parts() const
Definition: pk_keys.h:112
Botan::DER_SEQUENCE
@ DER_SEQUENCE
Definition: pk_keys.h:23
Botan::IEEE_1363
@ IEEE_1363
Definition: pk_keys.h:23

References Botan::DER_SEQUENCE, and Botan::IEEE_1363.

Referenced by Botan::X509_Object::choose_sig_format(), and Botan::X509_Object::verify_signature().

## ◆ estimated_strength()

size_t Botan::RSA_PublicKey::estimated_strength | ( |  | ) | const
| override virtual

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implements Botan::Public_Key.

Definition at line 139 of file rsa.cpp.

140 {
141 return if_work_factor(key_length());
142 }
Botan::RSA_PublicKey::key_length
size_t key_length() const override
Definition: rsa.cpp:134
Botan::if_work_factor
size_t if_work_factor(size_t bits)
Definition: workfactor.cpp:38

References Botan::if_work_factor(), and key_length().

## ◆ fingerprint_public()

std::string Botan::Public_Key::fingerprint_public | ( | const std::string & | alg = `"SHA-256"` | ) | const
| inherited

Returns
  Hash of the subject public key

Definition at line 77 of file pk_keys.cpp.

78 {
79 return create_hex_fingerprint(subject_public_key(), hash_algo);
80 }
Botan::Public_Key::subject_public_key
std::vector< uint8_t > subject_public_key() const
Definition: pk_keys.cpp:38
Botan::create_hex_fingerprint
std::string create_hex_fingerprint(const uint8_t bits[], size_t bits_len, const std::string &hash_name)
Definition: pk_keys.cpp:17
hash_algo
AlgorithmIdentifier hash_algo
Definition: x509_obj.cpp:22

References Botan::create_hex_fingerprint(), hash_algo, and Botan::Public_Key::subject_public_key().

## ◆ get_e()

const BigInt & Botan::RSA_PublicKey::get_e | ( |  | ) | const

Returns
  public exponent

Definition at line 105 of file rsa.cpp.

105{ return m_public->get_e(); }
Botan::RSA_PublicKey::m_public
std::shared_ptr< const RSA_Public_Data > m_public
Definition: rsa.h:86

References m_public.

Referenced by check_key(), Botan::RSA_PrivateKey::check_key(), Botan::RSA_PrivateKey::private_key_bits(), and public_key_bits().

## ◆ get_n()

const BigInt & Botan::RSA_PublicKey::get_n | ( |  | ) | const

Returns
  public modulus

Definition at line 104 of file rsa.cpp.

104{ return m_public->get_n(); }

References m_public.

Referenced by check_key(), Botan::RSA_PrivateKey::check_key(), Botan::RSA_PrivateKey::private_key_bits(), and public_key_bits().

## ◆ get_oid()

OID Botan::Public_Key::get_oid | ( |  | ) | const
| virtual inherited

Get the OID of the underlying public key scheme.

Returns
  OID of the public key scheme

Reimplemented in Botan::XMSS_WOTS_Addressed_PublicKey.

Definition at line 53 of file pk_keys.cpp.

54 {
55 const OID o = OIDS::str2oid_or_empty(algo_name());
56 if(o.empty())
57 throw Lookup_Error("PK algo " + algo_name() + " has no defined OIDs");
58 return o;
59 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0
Botan::OIDS::str2oid_or_empty
BOTAN_UNSTABLE_API OID str2oid_or_empty(const std::string &name)
Definition: oids.cpp:116

References Botan::Public_Key::algo_name(), Botan::OID::empty(), and Botan::OIDS::str2oid_or_empty().

Referenced by Botan::TPM_PrivateKey::algorithm_identifier(), Botan::Curve25519_PublicKey::algorithm_identifier(), Botan::DL_Scheme_PublicKey::algorithm_identifier(), Botan::EC_PublicKey::algorithm_identifier(), Botan::Ed25519_PublicKey::algorithm_identifier(), Botan::GOST_3410_PublicKey::algorithm_identifier(), Botan::McEliece_PublicKey::algorithm_identifier(), algorithm_identifier(), and Botan::XMSS_WOTS_Addressed_PublicKey::get_oid().

## ◆ init()

void Botan::RSA_PublicKey::init | ( | BigInt && | n,
|  | BigInt && | e
| ) |  |
| protected

Definition at line 107 of file rsa.cpp.

108 {
109 if(n.is_negative() || n.is_even() || e.is_negative() || e.is_even())
110 throw Decoding_Error("Invalid RSA public key parameters");
111 m_public = std::make_shared<RSA_Public_Data>(std::move(n), std::move(e));
112 }

References m_public.

Referenced by Botan::RSA_PrivateKey::RSA_PrivateKey(), and RSA_PublicKey().

## ◆ key_length()

size_t Botan::RSA_PublicKey::key_length | ( |  | ) | const
| override virtual

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implements Botan::Public_Key.

Definition at line 134 of file rsa.cpp.

135 {
136 return m_public->public_modulus_bits();
137 }

References m_public.

Referenced by estimated_strength().

## ◆ message_part_size()

virtual size_t Botan::Public_Key::message_part_size | ( |  | ) | const
| inline virtual inherited

Returns how large each of the message parts refered to by message_parts() is

This function is public but applications should have few reasons to ever call this.

Returns
  size of the message parts in bits

Reimplemented in Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::GOST_3410_PublicKey, and Botan::SM2_PublicKey.

Definition at line 123 of file pk_keys.h.

123{ return 0; }

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

## ◆ message_parts()

virtual size_t Botan::Public_Key::message_parts | ( |  | ) | const
| inline virtual inherited

Returns more than 1 if the output of this algorithm (ciphertext, signature) should be treated as more than one value. This is used for algorithms like DSA and ECDSA, where the (r,s) output pair can be encoded as either a plain binary list or a TLV tagged DER encoding depending on the protocol.

This function is public but applications should have few reasons to ever call this.

Returns
  number of message parts

Reimplemented in Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::GOST_3410_PublicKey, and Botan::SM2_PublicKey.

Definition at line 112 of file pk_keys.h.

112{ return 1; }

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

## ◆ public_data()

std::shared_ptr< const RSA_Public_Data > Botan::RSA_PublicKey::public_data | ( |  | ) | const

Definition at line 99 of file rsa.cpp.

100 {
101 return m_public;
102 }

References m_public.

## ◆ public_key_bits()

std::vector< uint8_t > Botan::RSA_PublicKey::public_key_bits | ( |  | ) | const
| override virtual

Returns
  BER encoded public key bits

Implements Botan::Public_Key.

Definition at line 149 of file rsa.cpp.

150 {
151 std::vector<uint8_t> output;
152 DER_Encoder der(output);
153 der.start_cons(SEQUENCE)
154 .encode(get_n())
155 .encode(get_e())
156 .end_cons();
157
158 return output;
159 }

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), get_e(), get_n(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

## ◆ subject_public_key()

std::vector< uint8_t > Botan::Public_Key::subject_public_key | ( |  | ) | const
| inherited

Returns
  X.509 subject key encoding for this key object

Definition at line 38 of file pk_keys.cpp.

39 {
40 std::vector<uint8_t> output;
41
42 DER_Encoder(output).start_cons(SEQUENCE)
43 .encode(algorithm_identifier())
44 .encode(public_key_bits(), BIT_STRING)
45 .end_cons();
46
47 return output;
48 }
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0
Botan::Public_Key::public_key_bits
virtual std::vector< uint8_t > public_key_bits() const =0
Botan::BIT_STRING
@ BIT_STRING
Definition: asn1_obj.h:37

References Botan::Public_Key::algorithm_identifier(), Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::Public_Key::public_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::X509::BER_encode(), Botan::PKCS10_Request::create(), Botan::Public_Key::fingerprint_public(), and Botan::X509::PEM_encode().

## Member Data Documentation

## ◆ m_public

std::shared_ptr<const RSA_Public_Data> Botan::RSA_PublicKey::m_public
| protected

Definition at line 86 of file rsa.h.

Referenced by get_e(), get_n(), init(), key_length(), and public_data().

The documentation for this class was generated from the following files:

- src/lib/pubkey/rsa/rsa.h
- src/lib/pubkey/rsa/rsa.cpp